addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.skin == "nario") then return end
	if player.jumpamount == nil
		player.jumpamount = 0
	end
	if player.jumptimer == nil
		player.jumptimer = 0*TICRATE
	end
	if player.jumptimer > 0*TICRATE
		player.jumptimer = $ - 5
	end
	if (player.mo.eflags & MFE_JUSTHITFLOOR)
		player.jumptimer = 1*TICRATE
	end
	if (player.cmd.buttons & BT_JUMP) 
	and player.jumptimer > 0*TICRATE
	and not (player.pflags & PF_THOKKED)
		player.jumpamount = $ + 1
		player.pflags = $|PF_THOKKED
		if player.jumpamount == 1
			P_SetObjectMomZ(player.mo, 10*FRACUNIT)
			player.mo.state = S_PLAY_SPRING
		elseif player.jumpamount == 2
			if player.speed >= skins[player.mo.skin].runspeed/2
				P_SetObjectMomZ(player.mo, 17*FRACUNIT)
				player.jumpamount = -1
				player.mo.state = S_PLAY_ROLL
			elseif player.speed < skins[player.mo.skin].runspeed/2
				player.jumpamount = 0
				P_DoJump(player)
			end
		end
	end
	if not P_IsObjectOnGround(player.mo)
		player.jumptimer = 0*TICRATE
	end
	if player.jumptimer == 0*TICRATE
	and (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
		player.jumpamount = 0
	end
end)